//xmms2PlaylistActions.cs
using System;
using System.Threading;
using System.Diagnostics;

using Do.Universe;

namespace Do.Addins.xmms2{
	public class xmms2LoadAction : AbstractAction{
		
		public xmms2LoadAction(){
		}
		public override string Name{
			get{
				return "Load Playlist";
			}
		}
		public override string Description{
			get{
				return "Switch current xmms2 playlist";
			}
		}
		public override string Icon{
			get{
				return "edit-redo";
			}
		}
		
		public override Type[] SupportedItemTypes{
			get{
				return new Type[] {
					typeof (PlaylistItem),
				};
			}
		}

		public override IItem[] Perform (IItem[] items, IItem[] modifierItems){
			string command = string.Format("playlist load {0}", items[0].Name);	
			xmms2.Client(command, true);
			return null;
		}
	}
	
	public class xmms2ShuffleAction : AbstractAction{
		public xmms2ShuffleAction (){
		}

		public override string Name{
			get { return "Shuffle Playlist"; }
		}

		public override string Description{
			get { return "Shuffle selected xmms2 Playlist"; }
		}

		public override string Icon{
			get { return "media-playlist-shuffle"; }
		}

		public override Type[] SupportedItemTypes{ 
			get {
				return new Type[] {
					typeof (PlaylistItem),
				};
			}
		}

		public override IItem[] Perform (IItem[] items, IItem[] modifierItems){
			new Thread ((ThreadStart) delegate {
				xmms2.StartIfNeccessary();
				for(int i = 0; i < items.Length; i++){
					xmms2.Client(string.Format("shuffle {0}", items[i].Name));
				}
			}).Start();
			return null;
		}
	}
	
	public class xmms2RepeatAction : AbstractAction{
		public xmms2RepeatAction (){
		}

		public override string Name{
			get { return "Repeat"; }
		}

		public override string Description{
			get { return "Turn on repeat for selected xmms2 playlist"; }
		}

		public override string Icon{
			get { return "media-playlist-repeat"; }
		}

		public override Type[] SupportedItemTypes{ 
			get {
				return new Type[] {
					typeof (PlaylistItem),
				};
			}
		}

		public override IItem[] Perform (IItem[] items, IItem[] modifierItems){
			new Thread ((ThreadStart) delegate {
				xmms2.StartIfNeccessary();
				for(int i = 0; i < items.Length; i++){
					xmms2.Client(string.Format("coll attr Playlists/{0} jumplist {0}", items[i].Name));
				}//unfortunately, there is no way to turn off repeat
			}).Start();
			return null;
		}
	}
	
	public class xmms2CreatePlaylistAction : AbstractAction{
		public xmms2CreatePlaylistAction (){
		}

		public override string Name{
			get { return "Create Playlist"; }
		}

		public override string Description{
			get { return "Create new xmms2 playlist"; }
		}

		public override string Icon{
			get { return "document-new"; }
		}

		public override Type[] SupportedItemTypes{ 
			get {
				return new Type[] {
					typeof (TextItem),
				};
			}
		}

		public override IItem[] Perform (IItem[] items, IItem[] modifierItems){
			new Thread ((ThreadStart) delegate {
				xmms2.StartIfNeccessary();
				for(int i = 0; i < items.Length; i++){ // why not?
					xmms2.Client(string.Format("playlist create {0}", items[i].Name));
				}
			}).Start();
			return null;
		}
	}
	public class xmms2RemovePlaylistAction : AbstractAction{
		public xmms2RemovePlaylistAction (){
		}

		public override string Name{
			get { return "Remove Playlist"; }
		}

		public override string Description{
			get { return "Remove selected xmms2 playlist"; }
		}

		public override string Icon{
			get { return "gtk-remove"; }
		}

		public override Type[] SupportedItemTypes{ 
			get {
				return new Type[] {
					typeof (PlaylistItem),
				};
			}
		}

		public override IItem[] Perform (IItem[] items, IItem[] modifierItems){
			new Thread ((ThreadStart) delegate {
				xmms2.StartIfNeccessary();
				for(int i = 0; i < items.Length; i++){
					xmms2.Client(string.Format("playlist remove {0}", items[0].Name));
				}
			}).Start();
			return null;
		}
	}
}
