//xmms2QueueAction.cs

using System;
using System.Threading;
using System.Diagnostics;

using Do.Addins;
using Do.Universe;

namespace Do.Addins.xmms2{
	
	public class xmms2QueueAction : IAction{
		
		public xmms2QueueAction(){
		}
		
		public string Name {
			get { return "Queue"; }
		}

		public string Description {
			get { return "Queue an item in an xmms2 playlist"; }
		}

		public string Icon {
			get { return "gtk-add"; }
		}

		public  Type[] SupportedItemTypes{
			get {
				return new Type[] {
					typeof (MusicItem),
					typeof (PlaylistItem),
				};
			}
		}
		public Type[] SupportedModifierItemTypes{
			get{
				return new Type[]{
					typeof(PlaylistItem),
				};
			}
		}

		public bool ModifierItemsOptional{
			get{
				return true;
			}
		}
		public bool SupportsItem(IItem item){
			return true;
		}
		public bool SupportsModifierItemForItems(IItem[] items, IItem modItem){
			return true;
		}
		public IItem[] DynamicModifierItemsForItem(IItem item){
			return null;
		}

		public IItem[] Perform (IItem[] items, IItem[] ModifierItems){
			//return playlist for loading, DO NOT AUTOLOAD.
			//use Default playlist by default, duh
			string playlist;
			
			new Thread ((ThreadStart) delegate {
				xmms2.StartIfNeccessary ();
				if(ModifierItems.Length == 0){
					playlist = "Default";
				}else{
					playlist = ModifierItems[0].Name;
				}
				for(int i = 0; i < items.Length; i++){
					string enqueue = "addid ";
					if(items[i] is PlaylistItem){ 
						foreach (SongMusicItem song in xmms2.LoadSongsFor (items[i] as PlaylistItem)){
							enqueue += string.Format("{0} {1} ", playlist, song.Id);
						}
					}else{
						foreach (SongMusicItem song in xmms2.LoadSongsFor (items[i] as MusicItem)){
							enqueue += string.Format("{0} {1} ", playlist, song.Id);
						}
					}
					xmms2.Client (enqueue, true);
				}

			}).Start ();
			return null;
		}

	}
}
